var rotFlag;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 1050;
}

function loadContentHandler()
{
	try
	{
		rotFlag = true;
		
		var mFlag = false;
		var ua = navigator.userAgent;
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			mFlag = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			mFlag = true;
		}
		
		document.getElementById("showBtn").addEventListener("click", showCanvas);
		
		var w = 9;
		var h = 9;
		var d = 9;
		
		var p = 1;
		var q = 2;
		var r = 3;
		
		initModel(w, h, d, p, q, r, 0);
		
		
		
		document.getElementById("pSelect").addEventListener("click", openBox);
		document.getElementById("qSelect").addEventListener("click", openBox);
		
		var pItem = document.getElementsByClassName("pPulldown");
		var qItem = document.getElementsByClassName("qPulldown");
		
		var i=0;
		
		for(i=0; i<pItem.length; i++)
		{
			pItem[i].addEventListener("click", selectBox);
		}
		
		
		for(i=0; i<qItem.length; i++)
		{
			qItem[i].addEventListener("click", selectBox);
		}
		
		initTriangle();
		
		changeTriangle(p, q, r);
		
		document.getElementById("triangleBlock").style.display = "none";
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("resetBtn").addEventListener('click', resetHandler);
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("load:" + e.toString());
	}
}

function openBox(event)
{
	try
	{
		if(mode != "select")
		{
			return;
		}
		
		var str = event.currentTarget.id.substring(0, 1);
		var display;
		
		if(document.getElementsByClassName(str+"Pulldown")[0].style.display == "none" || document.getElementsByClassName(str+"Pulldown")[0].style.display == "")
		{
			display = "block";
		}
		else
		{
			display = "none";
		}
		
		var items = document.getElementsByClassName(str+"Pulldown");
		var i;
		
		for(i=0; i<items.length; i++)
		{
			items[i].style.display = display;
		}
		
		if(str == "p")
		{
			str = "q";
		}
		else
		{
			str = "p";
		}
		
		var items = document.getElementsByClassName(str+"Pulldown");
		for(i=0; i<items.length; i++)
		{
			items[i].style.display = "none";
		}
	}
	catch(e)
	{
		alert("openBox:" + e.toString());	
	}
}

function closePulldown()
{
	
	var items = document.getElementsByClassName("pPulldown");
	var i;
	
	for(i=0; i<items.length; i++)
	{
		items[i].style.display = "none";
	}
	
	items = document.getElementsByClassName("qPulldown");
	for(i=0; i<items.length; i++)
	{
		items[i].style.display = "none";
	}
		
}

function selectBox(event)
{
	try
	{
		if(mode != "select")
		{
			return;
		}
		
		var str = event.currentTarget.id.substring(0, 1);
		var num = Number(event.currentTarget.id.substring(1, 2));
		
		if((str == "p" && pNum != num) || (str == "q" && qNum != num))
		{
			document.getElementById(str+"Select").innerHTML = num;
			
			//3Dモデルの見た目を変更
			var p = Number(document.getElementById("pSelect").innerHTML);
			var q = Number(document.getElementById("qSelect").innerHTML);
			
			if(isNaN(p))
			{
				p = 0;	
			}
			
			if(isNaN(q))
			{
				q = 0;
			}
			
			//断面図の変更
			changeSurfacePosition(p, q, 3);
			
			
			//描画の変更
			changeTriangle(p, q, 3);
		}
		
		var items = document.getElementsByClassName(str+"Pulldown");
		for(var i=0; i<items.length; i++)
		{
			items[i].style.display = "none";
		}
	}
	catch(e)
	{
		alert("selectBox:" + e.toString());	
	}
}


function showCanvas(e)
{
	if(document.getElementById("triangleBlock").style.display == "none")
	{
		document.getElementById("showBtn").innerHTML = "閉じる";
		document.getElementById("triangleBlock").style.display = "block";
		
		var fw = document.getElementById("iframe").contentWindow;
		
		var p = fw.pNum;
		var q = fw.qNum;
		
		changeTriangle(p, q, 3);
	}
	else
	{
		document.getElementById("showBtn").innerHTML = "断面を見る";
		document.getElementById("triangleBlock").style.display = "none";
	}
}

var cc;
var cs;
var shape;
var textP;
var textQ;
var textR;

var lengPQ;
var lengQR;
var lengRP;

function initTriangle()
{
	try
	{
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		
		
		//三角形描画用のShape
		shape = new createjs.Shape();
		cs.addChild(shape);
		
		//頂点テキスト
		textP = new createjs.Text("P", "36px Arial", "#000");
		textQ = new createjs.Text("Q", "36px Arial", "#000");
		textR = new createjs.Text("C", "36px Arial", "#000");
		cs.addChild(textP);
		cs.addChild(textQ);
		cs.addChild(textR);
		
		//辺の長さ
		lengPQ = new createjs.Container();
		lengQR = new createjs.Container();
		lengRP = new createjs.Container();
		
		cs.addChild(lengPQ);
		cs.addChild(lengQR);
		cs.addChild(lengRP);
		
		cs.update();
	}
	catch(e)
	{
		alert("initTriangle:" + e.toString());	
	}
}

function changeTriangle(p, q, r)
{
	try
	{
		if(p == 0 || q == 0 || r == 0)
		{
			return;
		}
		
		var sW = cc.width;
		var sH = cc.height;
		
		//初期化
		shape.graphics.clear();
		
		while(lengPQ.numChildren)
		{
			lengPQ.removeChildAt(0);
		}
		
		while(lengQR.numChildren)
		{
			lengQR.removeChildAt(0);
		}
		
		while(lengRP.numChildren)
		{
			lengRP.removeChildAt(0);
		}
		
		createSqrtText(lengPQ, p, q);
		createSqrtText(lengQR, q, r);
		createSqrtText(lengRP, r, p);
		
		
		var rate = 100;
		
		var pq = rate * Math.sqrt(p*p+q*q);
		var qr = rate * Math.sqrt(q*q+r*r);
		var rp = rate * Math.sqrt(r*r+p*p);
		
		//余弦定理で角度を算出
		var cosQ = (pq*pq+qr*qr-rp*rp)/(2*pq*qr);
		
		var h = pq * Math.sqrt(1-cosQ*cosQ);
		
		var pnt = [[,],[,],[,]];
		
		//座標
		pnt[0][0] = sW/2 - qr/2 + pq * cosQ;
		pnt[0][1] = sH/2 - h/2;
		
		pnt[1][0] = sW/2 - qr/2;
		pnt[1][1] = sH/2 + h/2;
		
		pnt[2][0] = sW/2 + qr/2;
		pnt[2][1] = sH/2 + h/2;
		
		//断面の描画
		shape.graphics.setStrokeStyle(2);
		shape.graphics.beginStroke("rgba(0,0,0,1)");
		shape.graphics.beginFill("rgba(0,159,232,0.2)");
		shape.graphics.moveTo(pnt[0][0], pnt[0][1]);
		shape.graphics.lineTo(pnt[1][0], pnt[1][1]);
		shape.graphics.lineTo(pnt[2][0], pnt[2][1]);
		shape.graphics.lineTo(pnt[0][0], pnt[0][1]);
		shape.graphics.lineTo(pnt[1][0], pnt[1][1]);
		shape.graphics.endFill();
		
		//頂点の表示位置
		textP.x = pnt[0][0] - textP.getBounds().width/2;
		textP.y = pnt[0][1] - textP.getBounds().height;
		
		textQ.x = pnt[1][0] - textQ.getBounds().width - 5;
		textQ.y = pnt[1][1] - textQ.getBounds().height/2;
		
		textR.x = pnt[2][0] + 5;
		textR.y = pnt[2][1] - textQ.getBounds().height/2;
		
		if(p != 0 && q != 0)
		{
			//長さの表示位置
			lengPQ.x = (pnt[0][0] + pnt[1][0])/2 - lengPQ.getBounds().width-lengPQ.getBounds().height;
			lengPQ.y = (pnt[0][1] + pnt[1][1])/2 - lengPQ.getBounds().height/2;
			
			lengQR.x = sW/2 - lengQR.getBounds().width/2 - lengQR.getBounds().height;
			lengQR.y = pnt[1][1] + 10;
			
			lengRP.x = (pnt[2][0] + pnt[0][0])/2 + lengRP.getBounds().height;
			lengRP.y = (pnt[2][1] + pnt[0][1])/2 - lengRP.getBounds().height/2;
		}
		
		if(pNum == 0 || qNum == 0)
		{
			document.getElementById("showBtn").style.display = "none";
		}
		else if(document.getElementById("showBtn").style.display == "none" && document.getElementById("triangleBlock").style.display == "none")
		{
			document.getElementById("showBtn").style.display = "inline-block";
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("changeTriangle:" + e.toString());	
	}
}

function createSqrtText(container, n0, n1)
{
	try
	{
		var size = 36;
		var sq = new createjs.Shape();
		
		var sw;
		
		if(n0 == 1 && n1 == 1)
		{
			var t1 = new createjs.Text("2", size.toString()+"px Arial", "#000");
			
			sw = t1.getBounds().width + t1.getBounds().height/2;
			
			container.addChild(t1);
			container.addChild(sq);
			
			drawSqrt(sq, t1.getBounds().width, t1.getBounds().height);
			
			t1.x = sw - t1.getBounds().width;
			t1.y = 5;
		}
		else if((n0 == 1 && n1 == 2) || (n0 == 2 && n1 == 1))
		{
			var t2 = new createjs.Text("5", size.toString()+"px Arial", "#000");
			
			sw = t2.getBounds().width + t2.getBounds().height/2;
			
			container.addChild(t2);
			container.addChild(sq);
			
			drawSqrt(sq, t2.getBounds().width, t2.getBounds().height);
			
			t2.x = sw - t2.getBounds().width;
			t2.y = 5;
		}
		else if((n0 == 1 && n1 == 3) || (n0 == 3 && n1 == 1))
		{
			var t3 = new createjs.Text("10", size.toString()+"px Arial", "#000");
			
			sw = t3.getBounds().width + t3.getBounds().height/2;
			
			container.addChild(t3);
			container.addChild(sq);
			
			drawSqrt(sq, t3.getBounds().width, t3.getBounds().height);
			
			t3.x = sw - t3.getBounds().width;
			t3.y = 5;
		}
		else if(n0 == 2 && n1 == 2)
		{
			var t4 = new createjs.Text("2", size.toString()+"px Arial", "#000");
			var t5 = new createjs.Text("2", size.toString()+"px Arial", "#000");
			
			sw = t5.getBounds().width + t5.getBounds().height/2;
			
			container.addChild(t4);
			container.addChild(t5);
			container.addChild(sq);
			
			drawSqrt(sq, t5.getBounds().width, t5.getBounds().height);
			
			t4.y = 5;
			sq.x = t4.getBounds().width + 2;
			t5.y = 5;
			t5.x = t4.getBounds().width + sw + 2 - t5.getBounds().width;
		}
		else if((n0 == 2 && n1 == 3) || (n0 == 3 && n1 == 2))
		{
			var t6 = new createjs.Text("13", size.toString()+"px Arial", "#000");
			
			sw = t6.getBounds().width + t6.getBounds().height/2;
			
			container.addChild(t6);
			container.addChild(sq);
			
			drawSqrt(sq, t6.getBounds().width, t6.getBounds().height);
			
			t6.x = sw - t6.getBounds().width;

			t6.y = 5;
		}
		else if(n0 == 3 && n1 == 3)
		{
			var t7 = new createjs.Text("3", size.toString()+"px Arial", "#000");
			var t8 = new createjs.Text("2", size.toString()+"px Arial", "#000");
			
			sw = t8.getBounds().width + t8.getBounds().height/2;
			
			container.addChild(t7);
			container.addChild(t8);
			container.addChild(sq);
			
			drawSqrt(sq, t8.getBounds().width, t8.getBounds().height);
			
			t7.y = 5;
			sq.x = t7.getBounds().width + 2;
			t8.y = 5;
			t8.x = t7.getBounds().width + sw + 2 - t8.getBounds().width;
		}
	}
	catch(e)
	{
		alert("createSqrtText:" + e.toString());
	}
}


function drawSqrt(s, w, h)
{
	s.graphics.clear();
	
	s.graphics.setStrokeStyle(1.5);
	s.graphics.beginStroke("rgba(0,0,0,1)");
	
	s.graphics.moveTo(0, h-h/12 -5);
	s.graphics.lineTo(h/12, h-h/6 -5);
	s.graphics.lineTo(h/6, h - 2);
	s.graphics.lineTo(h/2, 0);
	s.graphics.lineTo(h/2 + w, 0);
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = camera.position.x;
		array[0][1] = camera.position.y;
		array[0][2] = camera.position.z;
		array[0][3] = controls.object.zoom;
		
		array[1] = [];
		array[1][0] = parseInt(document.getElementById("pSelect").innerHTML);
		array[1][1] = parseInt(document.getElementById("qSelect").innerHTML);
		
		if(document.getElementById("showBtn").innerHTML == "断面を見る")
		{
			array[1][2] = false;
		}
		else
		{
			array[1][2] = true;
		}
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		document.getElementById('p1').style.display = "none";
		document.getElementById('p2').style.display = "none";
		document.getElementById('p3').style.display = "none";
		document.getElementById('q1').style.display = "none";
		document.getElementById('q2').style.display = "none";
		document.getElementById('q3').style.display = "none";
		
		camera.position.x = array[0][0];
		camera.position.y = array[0][1];
		camera.position.z = array[0][2];
		
		controls.object.zoom = array[0][3];
		controls.object.updateProjectionMatrix();
		
		document.getElementById('pSelect').innerHTML = array[1][0];
		document.getElementById('qSelect').innerHTML = array[1][1];
		
		//立体の変更
		changeTriangle(array[1][0], array[1][1], 3);
		
		//断面図の変更
		changeSurfacePosition(array[1][0], array[1][1], 3);
		
		if(array[1][2])
		{
			document.getElementById("showBtn").innerHTML = "閉じる";
			document.getElementById("triangleBlock").style.display = "block";
		}
		else
		{
			document.getElementById("showBtn").innerHTML = "断面を見る";
			document.getElementById("triangleBlock").style.display = "none";
		}
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		document.getElementById('p1').style.display = "none";
		document.getElementById('p2').style.display = "none";
		document.getElementById('p3').style.display = "none";
		document.getElementById('q1').style.display = "none";
		document.getElementById('q2').style.display = "none";
		document.getElementById('q3').style.display = "none";
		
		camera.position.x = -12.47898;
		camera.position.y = 2.62306;
		camera.position.z = 15.40760;
		
		controls.object.zoom = 1;
		controls.object.updateProjectionMatrix();
		
		document.getElementById('pSelect').innerHTML = 1;
		document.getElementById('qSelect').innerHTML = 2;
		
		//立体の変更
		changeTriangle(1, 2, 3);
		
		//断面図の変更
		changeSurfacePosition(1, 2, 3);
		
		document.getElementById("showBtn").innerHTML = "断面を見る";
		document.getElementById("triangleBlock").style.display = "none";
		
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}
