// JavaScript Document

var canvas;
var stage;

//グラフの描画領域
var cW;
var cH;

//グラフの線
var line;

//中心のずれ
var cX;
var cY;

//めもり
var memori;
//1めもりあたりのドット間隔
var dot;
//グラフの線分描画間隔
var span;

//ドラッグ移動するポイント
var dragPoint;
var dragX;
var dragY;

//グラフのめもりごとのテキストを格納
var textArray;

//数式
var expText

var grid;
var tA;

//帯
var area;
//矢印
var arrow;

var browse;


var m_on;

var expA;
var expB;
var expC;

function initGraph(cx, cy, m, d, s, f)
{
	try
	{
		canvas = document.getElementById("canvas");
		stage = new createjs.Stage(canvas);
		
		createjs.Touch.enable(stage);
		
		textArray = new Array();
		
		memori = m;
		dot = d;
		span = s;
		
		cW = canvas.width;
		cH = canvas.height;
		
		m_on = false;
		
		
		//グリッドの設定
		grid = new createjs.Shape();
		stage.addChild(grid);
		
		//帯
		area = new createjs.Shape();
		stage.addChild(area);
		
		//グラフの線
		line = new createjs.Shape();
		stage.addChild(line);
		
		//矢印
		arrow = new createjs.Shape();
		stage.addChild(arrow);
		
		expText = new createjs.Container();
		stage.addChild(expText);
		
		//つかんで動かすポイント
		dragPoint =  new createjs.Container();
		var p = new createjs.Shape();
		p.graphics.setStrokeStyle(0);
		p.graphics.beginStroke("rgba(0,0,0,0)");
		p.graphics.beginFill("rgba(0,0,0,1)");
		p.graphics.drawCircle(0, 0, 5);
		p.graphics.beginFill("rgba(0,0,0,0.01)");
		p.graphics.drawCircle(0, 0, 20);
		p.graphics.endFill();
		
		dragPoint.addChild(p);
		
		stage.addChild(dragPoint);
		
		ua = navigator.userAgent;
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			eventStr = "mousedown";
			browse = false;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			eventStr = "mousedown";
			browse = false;
		}
		else
		{
			eventStr = "mousedown";
			browse = false;
		}
		
		dragPoint.addEventListener(eventStr, pointDragStart);
		dragPoint.name ="dragPoint";
		
		tA = new createjs.Text("a", "20px Arial", "#000000");
		
		stage.addChild(tA);
		
	}
	catch(e)
	{
		alert("initGraph:" + e.toString());
	}
}

function pointDragStart(e)
{
	try
	{
		m_on = true;
		
		if(browse)
		{
			e.currentTarget.addEventListener("touchmove", pointDragMove);
			e.currentTarget.addEventListener("touchend", pointDragStop);
			e.currentTarget.addEventListener("touchcancel", pointDragStop);	
		}
		else
		{
			e.currentTarget.addEventListener("pressmove", pointDragMove);
			e.currentTarget.addEventListener("mouseup", pointDragStop);
			e.currentTarget.addEventListener("mouseout", pointDragStop);
		}
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}

function pointDragMove(event)
{
	try
	{
		var cnt = Math.round((event.stageX - (cW/2 + cX))/dot);
		
		if(dragX != cnt)
		{
			if(stage.getChildByName("x" + cnt) == null)return;
			
			stage.getChildByName("x" + dragX).alpha = 1;
			
			dragX = cnt;
			
			//ドットの位置に合わせる
			dragPoint.x = (cW/2 + cX) + cnt * dot;
			
			tA.x = dragPoint.x - tA.getBounds().width/2;
			
			stage.getChildByName("x" + dragX).alpha = 0;
			
			var numY = expA * cnt * cnt + expB * cnt + expC;
			
			expText.y = cH/2 + cY + numY * -dot - expText.getBounds().height/2;
			
			if(stage.getChildByName("y"+dragY) != null)
			{
				stage.getChildByName("y" + dragY).alpha = 1;
			}
			
			if(stage.getChildByName("y"+numY) != null)
			{
				stage.getChildByName("y" + numY).alpha = 0;
			}
			
			dragY = numY;
			
			if(dragPoint.x >= cW/2 +cX)
			{
				expText.x = cW/2 + cX - expText.getBounds().width - 10;
			}
			else
			{
				expText.x = cW/2 + cX + 10;
			}
			
			//グラフの再描画
			drawLine(document.getElementById("gridCheck").checked);
			
			changeArea();
			changeArrow();
			
			stage.update();
		}
	}
	catch(e)
	{
		alert("pointDragMove:" + e.toString());
	}
}

function pointDragStop(e)
{
	try
	{
		//イベント削除
		if(browse)
		{
			dragPoint.removeEventListener("touchmove", pointDragMove);
			dragPoint.removeEventListener("touchend", pointDragStop);
			dragPoint.removeEventListener("touchcancel", pointDragStop);	
		}
		else
		{
			dragPoint.removeEventListener("mousemove", pointDragMove);
			dragPoint.removeEventListener("mouseup", pointDragStop);
			dragPoint.removeEventListener("mouseout", pointDragStop);
		}
		
		m_on = false;
	}
	catch(e)
	{
		alert("pointDragStop:" + e.toString());
	}
}

//グラフの背景描画
function drawGraphBase(mx, my, f0, f1)
{
	try
	{
		//受け取った最大値もしくは最小値からグラフの中心からのずれを算出
		
		cX = -mx * dot;
		
		//alert("mx=" + mx + ", my=" + my);
		
		//下に凸
		if(f0 === true)
		{
			
			if(my >= 0)
			{
				cY = 540/2 - dot;
			}
			//最小値とx軸が同時に表示できない場合はx軸を出す
			else if(540/2 - dot + my * dot < -540/2 + dot)
			{
				cY = -540/2 + dot;
			}
			//
			else
			{
				cY = 540/2 - dot + my * dot;
			}
		}
		//上に凸
		else
		{
			if(my <=0)
			{
				cY = -540/2 + dot;
			}
			else if(-540/2+dot + my * dot > 540/2 - dot)
			{
				cY = 540/2 - dot;
			}
			else
			{
				cY = -540/2 + dot + my * dot; 
			}
		}
			
		var g = grid.graphics;
		g.clear();
		
		var i;
		
		//グラフの方眼
		if(f1)
		{
			g.beginStroke("#00A0FF");
			g.setStrokeStyle(0.5);
			
			//縦線
			for(i = cW/2+cX - dot; i>=0; i-=dot)
			{
				g.moveTo(i, 0);
				g.lineTo(i, cH);
			}
			for(i = cW/2+cX + dot; i<= cW; i+=dot)
			{
				g.moveTo(i, 0);
				g.lineTo(i, cH);
			}
			
			//横線
			for(i = cH/2+cY - dot; i>=0; i-=dot)
			{
				g.moveTo(0, i);
				g.lineTo(cW, i);
			}
			for(i = cH/2+cY + dot; i<=cH; i+=dot)
			{
				g.moveTo(0, i);
				g.lineTo(cW, i);
			}
		}
		
		g.beginStroke("#000000");
		
		//三角形
		g.setStrokeStyle(0);
		g.beginFill("#000000");
		g.moveTo(cW-10, cH/2 + cY);
		g.lineTo(cW-30, cH/2-5 + cY);
		g.lineTo(cW-30, cH/2+5 + cY);
		
		g.moveTo(cW/2 + cX, 10);
		g.lineTo(cW/2-5 + cX, 30);
		g.lineTo(cW/2+5 + cX, 30);
		g.endFill();
		
		g.setStrokeStyle(2);
		
		//x軸
		g.moveTo(10, cH/2 + cY);
		g.lineTo(cW-30, cH/2 + cY);
		
		//y軸
		g.moveTo(cW/2 + cX, 30);
		g.lineTo(cW/2 + cX, cH-10);
		
		
		if(textArray.length > 0)
		{
			for(i=0; i<textArray.length; i++)
			{
				stage.removeChild(textArray[i]);
			}
			
			textArray = new Array();
		}
		
		//文字の設定
		//原点
		var n0 = new createjs.Text("0", "20px Arial", "#000000");
		stage.addChild(n0);
		n0.x = cW/2 + cX - n0.getBounds().width-5;
		n0.y = cH/2 + cY + 5;
		
		n0.name = "x0";
		textArray.push(n0);
		
		var cnt=1;
		//X座標
		for(i=cW/2 + cX + dot; i<cW; i+=dot)
		{
			var tx0 = new createjs.Text((cnt * memori).toString(), "20px Arial", "#000000");
			stage.addChild(tx0);
			tx0.x = i - tx0.getBounds().width/2;
			tx0.y = cH/2 + cY + 5;
			
			textArray.push(tx0);
			tx0.name = "x"+cnt.toString();
			
			if(cnt == 1)
			{
				tx0.alpha = 0;
			}
			
			cnt++;
		}
		
		cnt=-1;
		for(i=cW/2 + cX - dot; i > 0;i-=dot)
		{
			var tx1 = new createjs.Text((cnt * memori).toString(), "20px Arial", "#000000");
			stage.addChild(tx1);
			tx1.x = i - tx1.getBounds().width/2;
			tx1.y = cH/2 + cY + 5;
			
			textArray.push(tx1);
			tx1.name = "x"+cnt.toString();
			
			cnt--;
		}
		
		var cnt=1;
		//Y座標
		for(i=cH/2 + cY - dot; i > 0; i-=dot)
		{
			var ty0 = new createjs.Text((cnt * memori).toString(), "20px Arial", "#000000");
			stage.addChild(ty0);
			ty0.x = cW/2 + cX - ty0.getBounds().width - 5;
			ty0.y = i - ty0.getBounds().height/2;
			
			textArray.push(ty0);
			ty0.name = "y"+cnt.toString();
			
			cnt++;
		}
		
		var cnt=-1;
		for(i=cH/2 + cY + dot; i < cH; i+=dot)
		{
			var ty1 = new createjs.Text((cnt * memori).toString(), "20px Arial", "#000000");
			stage.addChild(ty1);
			ty1.x = cW/2 + cX - ty1.getBounds().width - 5;
			ty1.y = i - ty1.getBounds().height/2;
			
			textArray.push(ty1);
			ty1.name = "y"+cnt.toString();
			
			cnt--;
		}
		
		//aの点とテキストを中心より1つ横の位置に設定
		dragPoint.x = cW/2 + cX + dot;
		dragPoint.y = cH/2 + cY;
		dragX = 1;
		
		tA.x = dragPoint.x - tA.getBounds().width/2;
		tA.y = cH/2 + cY + 5;
		
		//yの値を取得
		var nY = expA * dragX * dragX + expB * dragX + expC;
		
		if(stage.getChildByName("y"+nY) != null)
		{
			stage.getChildByName("y"+nY).alpha = 0;
		}
		
		dragY = nY;
		
		stage.setChildIndex(dragPoint, stage.getNumChildren()-1);
		
		
		changeArea();
		changeArrow();
	}
	catch(e)
	{
		alert("drawGraphBase:" + e.toString());
	}
}

function changeExpression(a, b, c, p)
{
	try
	{
		while(expText.getNumChildren() > 0)
		{
			expText.removeChildAt(0);
		}
		
		var str0 = "";
		var str1 = "";
		
		if(a == 1)
		{
			switch(p)
			{
				case 0:
					str0 = "a";
					break;	
				case 1:
					str0 = "a";
					break;	
				case 2:
					str0 = "(a";
					break;	
				case 3:
					str0 = "(a";
					break;	
				case 4:
					str0 = "a";
					break;	
			}
		}
		else if(a == -1)
		{
			switch(p)
			{
				case 0:
					str0 = "-a";
					break;	
				case 1:
					str0 = "-a";
					break;	
				case 2:
					str0 = "-(a";
					break;	
				case 3:
					str0 = "-(a";
					break;	
				case 4:
					str0 = "-a";
					break;	
			}
		}
		else
		{
			if(p == 0 || p == 1 || p == 4)
			{
				str0 = a.toString() + "a";
			}
			else
			{
				str0 = a.toString() + "(a";
			}
		}
		
		if(b == 0)
		{
			if(p == 2 || p == 3)
			{
				str0 = str0.substring(0, str0.length-2) + str0.substring(str0.length-1, str0.length);
			}
		}
		else if(b < 0)
		{
			if(p == 1)
			{
				str1 = b.toString();
			}
			else if(p == 2 || p == 3)
			{
				str0 = str0 + "+" + (-b).toString()+")";
			}
			else if(p == 4)
			{
				if(b == -1)
				{
					str1 = "-a";
				}
				else
				{
					str1 = b.toString()+"a";
				}
			}
		}
		else
		{
			if(p == 1)
			{
				str1 = "+" + b.toString();
			}
			else if(p == 2 || p == 3)
			{
				str0 = str0 + "-" + b.toString() + ")";
			}
			else if(p == 4)
			{
				if(b == 1)
				{
					str1 = "+a";
				}
				else
				{
					str1 = "+" + b.toString() + "a";
				}
			}
		}
		
		if(c < 0)
		{
			if(p == 3)
			{
				str1 = c.toString();
			}
			else if(p == 4)
			{
				str1 = str1 + c.toString();
			}
		}
		else if(c > 0)
		{
			if(p == 3)
			{
				str1 = "+" + c.toString();
			}
			else if(p == 4)
			{
				str1 = str1 + "+" + c.toString();
			}
		}
		
		var t0 = new createjs.Text(str0, "20px Arial", "#000000");
		expText.addChild(t0);
		
		var powText = new createjs.Text("2", "10px Arial", "#000000");
		powText.x = expText.getBounds().width;
		expText.addChild(powText);
		
		if(str1 != "")
		{
			var t1 = new createjs.Text(str1, "20px Arial", "#000000");
			t1.x = expText.getBounds().width;
			expText.addChild(t1);
		}
		
		expText.x = cW/2 + cX - expText.getBounds().width - 10;
		
		expText.y = cH/2 + cY - dot * dragY - expText.getBounds().height/2;
		
		stage.update();
	}
	catch(e)
	{
		alert("changeExplain:" + e.toString());
	}
}

function changeArea()
{
	try
	{
		area.graphics.clear();
		area.graphics.setStrokeStyle(0);
		area.graphics.beginStroke("rgba(0,0,0,0)");
		area.graphics.beginFill("rgba(255,170, 0, 0.25)");
		area.graphics.drawRect(cW/2+cX, 0, dragPoint.x - (cW/2 + cX), cH);
		area.graphics.endFill();
	}
	catch(e)
	{
		alert("changeArea:" + e.toString());
	}
}

function changeArrow()
{
	try
	{
		arrow.graphics.clear();
		
		//点aのX座標におけるグラフのY座標
		var pY = expA * dragX * dragX + expB * dragX + expC;
		
		var sub;
		
		//たての矢印
		if(pY != 0)
		{
			arrow.graphics.setStrokeStyle(1.5);
			arrow.graphics.beginStroke("#EA5504");
			arrow.graphics.moveTo(dragPoint.x, dragPoint.y);
			if(dragPoint.y < cH/2+cY-pY*dot)
			{
				sub = -5;
				
			}
			else
			{
				sub = 5;
			}
			arrow.graphics.lineTo(dragPoint.x, cH/2+cY-pY * dot + sub);
			
			arrow.graphics.setStrokeStyle(0);
			arrow.graphics.beginFill("#EA5504");
			arrow.graphics.moveTo(dragPoint.x, cH/2+cY-pY * dot + sub);
			arrow.graphics.lineTo(dragPoint.x-3, cH/2+cY-pY * dot + sub * 3);
			arrow.graphics.lineTo(dragPoint.x+3, cH/2+cY-pY * dot + sub * 3);
			arrow.graphics.lineTo(dragPoint.x, cH/2+cY-pY * dot + sub);
		}
		
		//横の矢印
		if(dragPoint.x != cW/2+cX)
		{
			arrow.graphics.setStrokeStyle(1.5);
			arrow.graphics.moveTo(dragPoint.x, cH/2+cY-pY * dot);
			arrow.graphics.lineTo(cW/2+cX, cH/2+cY-pY * dot);
			if(dragPoint.x < cW/2+cX)
			{
				sub = -5;
			}
			else
			{
				sub = 5;
			}
			
			arrow.graphics.setStrokeStyle(0);
			arrow.graphics.beginFill("#EA5504");
			arrow.graphics.moveTo(cW/2+cX, cH/2+cY-pY * dot);
			arrow.graphics.lineTo(cW/2+cX+sub * 3, cH/2+cY-pY * dot + 3);
			arrow.graphics.lineTo(cW/2+cX+sub * 3, cH/2+cY-pY * dot - 3);
			arrow.graphics.lineTo(cW/2+cX, cH/2+cY-pY * dot);
			
			
			arrow.graphics.setStrokeStyle(0);
			arrow.graphics.beginStroke("#000000");
			arrow.graphics.beginFill("#000000");
			arrow.graphics.drawCircle(cW/2+cX + dragX * dot, cH/2+cY-pY * dot, 5);
			arrow.graphics.endFill();
		}
		
		//最大値
		var minY;
		var maxY;
		
		//グラフとY軸の交点
		var pY0 = expC;
		
		//座標
		var mX = -expB/(2*expA);
		var mY = expC - ((expB * expB) / (4 * expA));
		
		var mFlag = false;
		
		//0～aの範囲内にグラフの最小値、もしくは最大値がある場合
		if((mX >= 0 && mX <= dragX) || (mX <= 0 && mX >= dragX))
		{
			mFlag = true;
			
			if(pY0 <= mY && pY0 <= pY)
			{
				minY = pY0;
			}
			else if(mY <= pY0 && mY <= pY)
			{
				minY = mY;
			}
			else
			{
				minY = pY;
			}
			
			if(pY0 >= mY && pY0 >= pY)
			{
				maxY = pY0;
			}
			else if(mY >= pY0 && mY >= pY)
			{
				maxY = mY;
			}
			else
			{
				maxY = pY;
			}
		}
		else
		{
			if(pY0 >= pY)
			{
				maxY = pY0;
				minY = pY;
			}
			else
			{
				maxY = pY;
				minY = pY0;
			}
		}
		
		arrow.graphics.setStrokeStyle(0);
		arrow.graphics.beginStroke("rgba(250, 85, 4, 0)");
		arrow.graphics.beginFill("rgba(250, 85, 4, 1)");
		arrow.graphics.drawCircle(cW/2+cX, cH/2+cY-minY*dot, 5);
		arrow.graphics.drawCircle(cW/2+cX, cH/2+cY-maxY*dot, 5);
		arrow.graphics.endFill();
		
		arrow.graphics.setStrokeStyle(3);
		arrow.graphics.beginStroke("rgba(250, 85, 4, 1)");
		arrow.graphics.moveTo(cW/2+cX, cH/2+cY-minY*dot);
		arrow.graphics.lineTo(cW/2+cX, cH/2+cY-maxY*dot);
		
		
		//グラフの最小値、もしくは最大値が範囲内に入る場合の矢印
		if(mFlag)
		{
			//たての矢印
			if(mY != 0)
			{
				arrow.graphics.setStrokeStyle(1.5);
				arrow.graphics.beginStroke("#EA5504");
				arrow.graphics.moveTo(cW/2 + cX + mX * dot, cH/2 + cY);
				arrow.graphics.lineTo(cW/2 + cX + mX * dot, cH/2 + cY - mY * dot);
				
				if(mY > 0)
				{
					sub = 5;
				}
				else
				{
					sub = -5;
				}
				
				arrow.graphics.setStrokeStyle(0);
				arrow.graphics.beginFill("#EA5504");
				arrow.graphics.moveTo(cW/2 + cX + mX * dot, cH/2 + cY - mY * dot);
				arrow.graphics.lineTo(cW/2 + cX + mX * dot - 3, cH/2 + cY - mY * dot + sub * 3);
				arrow.graphics.lineTo(cW/2 + cX + mX * dot + 3, cH/2 + cY - mY * dot + sub * 3);
				arrow.graphics.lineTo(cW/2 + cX + mX * dot, cH/2 + cY - mY * dot);
			}
			
			//横の矢印
			if(mX != 0)
			{
				arrow.graphics.setStrokeStyle(1.5);
				arrow.graphics.moveTo(cW/2 + cX + mX * dot, cH/2 + cY - mY * dot);
				arrow.graphics.lineTo(cW/2 + cX, cH/2 + cY - mY * dot);
				
				if(mX < 0)
				{
					sub = -5;
				}
				else
				{
					sub = 5;
				}
				
				arrow.graphics.setStrokeStyle(0);
				arrow.graphics.beginFill("#EA5504");
				arrow.graphics.moveTo(cW/2+cX, cH/2 + cY - mY * dot);
				arrow.graphics.lineTo(cW/2+cX+sub * 3, cH/2 + cY - mY * dot + 3);
				arrow.graphics.lineTo(cW/2+cX+sub * 3, cH/2 + cY - mY * dot - 3);
				arrow.graphics.lineTo(cW/2+cX, cH/2 + cY - mY * dot);
			}
		}
	}
	catch(e)
	{
		alert("changeArea:" + e.toString());
	}
}

//グラフの描画
function drawLine(checked)
{
	try
	{
		var g = line.graphics;
		g.clear();
				
		/*
		コンピュータの座標系はY座標は下にプラスで、左上が(0, 0)であることに注意
		*/
		
		//最大値もしくは最小値
		var mX = -expB/(2 * expA);
		var mY = expC - ((expB * expB) / (4 * expA));
		
		//コンピュータの座標系に調整
		mX = mX * dot + cW/2 + cX;
		mY = -mY * dot + cH/2 + cY;
		
		//領域に入っている場合
		var areaFlag = checkArea(mX);
		
		//線を引く場合
		var lineFlag = true;
		
		var mX0 = mX;
		
		var cnt = 0;
		
		var prevX = mX;
		var prevY = mY;
		
		var startFlag = true;
		var changeFlag = true;
		
		//グラフの右側
		while(true)
		{
			var y = calcExp(mX0 + span, mX, mY);
			
			if(areaFlag == true || (areaFlag == false && lineFlag == true))
			{
				if(changeFlag)
				{
					g.beginStroke("rgba(0 ,0, 0, 1)");
					g.setStrokeStyle(2);
					
					changeFlag = false;
				}
			}
			else
			{
				if(changeFlag)
				{
					g.beginStroke("rgba(0 ,0, 0, 0)");
					g.setStrokeStyle(2);
					
					changeFlag = false;
				}
			}
			
			if(startFlag)
			{
				g.moveTo(mX, mY);
					
				startFlag = false;
			}
			
			g.lineTo(mX0 + span, y);
			
			//入れ替え
			if(areaFlag == false)
			{
				cnt += Math.sqrt(span * span + (y - prevY) * (y - prevY));
				
				if(cnt > 20)
				{
					cnt = 0;
					lineFlag = !lineFlag;
					changeFlag = true;
				}
			}
			
			//下に凸で描画範囲外
			if(expA > 0 && y < 0)
			{
				break;
			}
			//上に凸で描画範囲外
			else if(expA < 0 && y > cH)
			{
				break;
			}
			
			prevX = mX0;
			prevY = y;
			
			mX0 += span;
			
			//領域の確認
			var f = checkArea(mX0);
			
			//領域が入れ替わる場合
			if(areaFlag != f)
			{
				lineFlag = false;
				changeFlag = true;
				cnt = 0;
				
				areaFlag = f;
			}
		}
		
		//値を初期化
		areaFlag = checkArea(mX);
		
		//線を引く場合
		lineFlag = true;
		
		mX0 = mX;
		
		cnt = 0;
		
		prevX = mX;
		prevY = mY;
		
		startFlag = true;
		changeFlag = true;
		
		//グラフの右側
		while(true)
		{
			var y = calcExp(mX0 - span, mX, mY);
			
			if(areaFlag == true || (areaFlag == false && lineFlag == true))
			{
				if(changeFlag)
				{
					g.beginStroke("rgba(0 ,0, 0, 1)");
					g.setStrokeStyle(2);
					
					changeFlag = false;
				}
			}
			else
			{
				if(changeFlag)
				{
					g.beginStroke("rgba(0 ,0, 0, 0)");
					g.setStrokeStyle(2);
					
					changeFlag = false;
				}
			}
			
			if(startFlag)
			{
				g.moveTo(mX, mY);
					
				startFlag = false;
			}
			
			g.lineTo(mX0 - span, y);
			
			//入れ替え
			if(areaFlag == false)
			{
				cnt += Math.sqrt(span * span + (y - prevY) * (y - prevY));
				
				if(cnt > 20)
				{
					cnt = 0;
					lineFlag = !lineFlag;
					changeFlag = true;
				}
			}
			
			//下に凸で描画範囲外
			if(expA > 0 && y < 0)
			{
				break;
			}
			//上に凸で描画範囲外
			else if(expA < 0 && y > cH)
			{
				break;
			}
			
			prevX = mX0;
			prevY = y;
			
			mX0 -= span;
			
			//領域の確認
			var f = checkArea(mX0);
			
			//領域が入れ替わる場合
			if(areaFlag != f)
			{
				lineFlag = false;
				changeFlag = true;
				cnt = 0;
				
				areaFlag = f;
			}	
		}
	}
	catch(e)
	{
		alert("drawLine:" + e.toString());
	}
}


function checkArea(x)
{
	var f;
	
	if(dragPoint.x < cW/2 + cX)
	{
		if(x >= dragPoint.x && x <= cW/2 + cX)
		{
			f = true;
		}
		else
		{
			f = false;
		}
	}
	else
	{
		if(x >= cW/2 + cX && x <= dragPoint.x)
		{
			f = true;
		}
		else
		{
			f = false;
		}
	}
	
	return f;
}

function calcExp(x, mX, mY)
{
	try
	{
		//alert(expA +", " + dot + ", " + span + ", " + x + ", " + mX + ", " + mY);
		var y = -expA/(dot/span) * Math.pow(x - mX, 2) + mY;
		return y;
	}
	catch(e)
	{
		alert("calcExp:" + e.toString());	
	}
}


